var random=function(max){return Math.floor(Math.random()*(max+1))};var calc_path=function(x1,y1,x2,y2,speed){var ac=y2-y1;var bc=x2-x1;var ab=Math.sqrt(Math.pow(ac,2)+Math.pow(bc,2));var de=(1.0*speed*ac)/ab;var be=(1.0*speed*bc)/ab;return{y:de,x:be}};var dist=function(x1,y1,x2,y2){var ac=y2-y1;var bc=x2-x1;return Math.sqrt(Math.pow(ac,2)+Math.pow(bc,2))}
var grid_to_pixel=function(gx,gy){if(gy==undefined){gy=gx.gy;gx=gx.gx}
return{x:gx*SET.pixels_per_square,y:gy*SET.pixels_per_square}};var pixel_to_grid=function(x,y){if(y==undefined){y=x.y;x=x.x}
var grid_x=Math.floor(x/SET.pixels_per_square);var grid_y=Math.floor(y/SET.pixels_per_square);return{gx:grid_x,gy:grid_y}};var center_of_square=function(gx,gy){if(gy==undefined){gy=gx.gy;gx=gx.gx}
var coords=grid_to_pixel(gx,gy);return{x:coords.x+SET.half_pixels_per_square,y:coords.y+SET.half_pixels_per_square}};var draw_square_in_grid=function(gx,gy){var pos=grid_to_pixel(gx,gy);rect(pos.x,pos.y,SET.pixels_per_square,SET.pixels_per_square)}
var draw_circle_in_grid=function(gx,gy){var pos=grid_to_pixel(gx,gy);var h=SET.half_pixels_per_square;var l=SET.pixels_per_square;ellipse(pos.x+h,pos.y+h,l-1,l-1)};var can_build_here=function(gx,gy){if(get_tower_at(gx,gy)!=!1)return!1;if((gx==SET.entrance.gx)&&(gy==SET.entrance.gy))return!1;if((gx==SET.exit.gx)&&(gy==SET.exit.gy))return!1;return!0};var get_tower_at=function(gx,gy){var cached=SET.grid_cache_at(gx,gy);if(cached.tower)return cached.tower;var towers=SET.rendering_groups[SET.tower_render_level];for(var i=0;i<towers.length;i++){var tower=towers[i];if(tower.gx==gx&&tower.gy==gy){cached.tower=tower;return tower}}
return!1};var get_terrain_at=function(gx,gy){var cached=SET.grid_cache_at(gx,gy);if(cached.terrain)return cached.terrain;var squares=SET.rendering_groups[SET.square_render_level];for(var i=0;i<squares.length;i++){var square=squares[i];if(square.gx==gx&&square.gy==gy){cached.terrain=square;return square}}
return}
var get_creep_nearest=function(x,y,sensitivity){if(!sensitivity)sensitivity=10;var creeps=SET.rendering_groups[SET.creep_render_level];var len=creeps.length;var nearest_creep;var distance=sensitivity;for(var i=0;i<len;i++){var creep=creeps[i];var d=dist(x,y,creep.x,creep.y);if(d<distance){distance=d;nearest_creep=creep}}
return(distance<sensitivity)?nearest_creep:undefined}
Object.extend=function(destination,source){for(var property in source){destination[property]=source[property]}
return destination};var pp=function(obj,depth){if(depth==undefined)depth=4;depth-=1;if(depth<=0)
return''+obj;if(obj instanceof Array){var str="[";obj.forEach(function(i){str+=pp(i,depth)+", "});return str+"]"}
if(obj instanceof String)
return'"'+str+'"';if(obj instanceof Object){var str="{";for(prop in obj){if(prop=="ancestor")
depth=0;str+=pp(prop,depth)+":"+pp(obj[prop],depth)+", "}
return str+"}"}
return''+obj}
var log=function(label,thing){if(thing==undefined)
$('#log').append(label+"<br/>");else $('#log').append(label+": "+pp(thing)+"<br/>")}
Array.prototype.equals=function(testArr){if(this.length!=testArr.length)return!1;for(var i=0;i<testArr.length;i++){if(this[i].equals){if(!this[i].equals(testArr[i]))return!1}
if(this[i]!=testArr[i])return!1}
return!0}
var insert_sorted=function(array,value,sortKey){var vkey=sortKey(value);var min=0;var max=array.length;var mid=-1;for(;;){if(max<=min){break}
mid=Math.floor((max+min)/2);if(mid>=array.length||mid<0){log("outofbounds in insert sorted");break}
if(vkey<=sortKey(array[mid]))
max=mid-1;else min=mid+1}
mid=Math.floor((max+min)/2);if(array[mid])
if(vkey>sortKey(array[mid]))
mid+=1;mid=Math.max(0,mid);var result=array.slice(0,mid).concat([value]).concat(array.slice(mid))
return result}
var move_towards=function(obj,x,y,tx,ty,speed){var path=calc_path(x,y,tx,ty,speed);obj.x+=path.x;obj.y+=path.y;obj.x=Math.max(0,Math.min(SET.width,obj.x));obj.y=Math.max(0,Math.min(SET.height,obj.y))}